#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double nullfunc(double iks) {
return(iks*(2-iks)); }

void main()
{
FILE *func;
func=fopen("1.dat","w");
double tau=0.001, X1=0., X2=2.,h, Ai, Bi, Ci;
int XSTEPS=100, TSTEPS=200, i, j;
h=(X2-X1)/XSTEPS;
double t[TSTEPS+1], x[XSTEPS+1], alpha[XSTEPS+1], beta[XSTEPS+1], u[XSTEPS+1];
for (i=0; i<TSTEPS+1; i++) t[i]=tau*i;
for (i=0; i<XSTEPS+1; i++) {x[i]=X1+i*h; u[i]=nullfunc(x[i]);}
alpha[1]=0; beta[1]=0;
Ai=Bi=4/h/h; Ci=-8/h/h-1/tau;
for (j=1; j<TSTEPS+1; j++)
	{
	for (i=2; i<XSTEPS+1; i++) {
		alpha[i]=-Bi/(Ai*alpha[i-1]+Ci);
		beta[i]=(-u[i-1]/tau-Ai*beta[i-1])/(Ai*alpha[i]+Ci); }
	u[XSTEPS]=0;
	for (i=XSTEPS-1; i>-1; i--)
		u[i]=alpha[i+1]*u[i+1]+beta[i+1];
	for(i=0; i<XSTEPS+1; i++) fprintf(func,"%f\t%f\t%f\n",t[j], x[i], u[i]);
	fprintf(func,"\n");
	}
}

